/*** X_ASGN.C ***/						#include	"main.h"

/***1***2***3***4***5***6***7***8***9***A***B***C***D***E***F***G***H***I***J***K***L***M***N****/
ctree *x_asgn(ctree *ptr){				/*** TT-Lang: A = X | (A0,A1,A2,...) = (X0,X1,X2,...) ***/
/***1***2***3***4***5***6***7***8***9***A***B***C***D***E***F***G***H***I***J***K***L***M***N****/

ctree	*a_root,*a_curr,*x_root,*x_curr;	dtab	*a,*x;
char	*RefV,*RefA;	int		mult;

// Note: We must *** Disable Sign Extension !! *** for RefV & RefA.  Because STR[I] & PTR[I] in
// TT-Script always intend 1[Bype] data.

/* Debug & PreCheck */
	chk_point(ptr);

/* Eval RHS&LHS */
	x_root = eva_expr(ptr->r,0); chk_error(ptr);	/* Eval All RHS wo "${...}" Eval (1st) */
	a_root = eva_expr(ptr->l,0); chk_error(ptr);	/* Eval All LHS wo "${...}" Eval (2nd) */

/* --- Multi Assign --- */
	mult = lcnt(a_root);
	for( int i=0 ; i<mult ; i++ ){		/* For All LHS ( Not RHS )								*/

	/* >Set Param(s) & Check Type(s) */
		x_curr=lptr( last_ct=x_root ,i); x=ctr2p_draw( last_ct=x_curr ); /*** RAW ***/
		if( x==NULL ){ continue; }; chk_vtype(x,".*",i);	// Allow & Skip <GAP> //
		a_curr=lptr( last_ct=a_root ,i); a=ctr2p_draw( last_ct=a_curr ); /*** RAW ***/
		if( a==NULL ){ continue; }; chk_vtype(a,"U*",i);	// Allow & Skip <GAP> //

	/* >Do DeRefs!! ( if applicable ) */
		if( x->type=='R' ){				// RVAL参照先 1[Byte] 値を RefV に設定する。
			if( (RefV=deref_a(x))==NULL ){ flag_exerr=E_REFIDX; last_ct=x_curr; /* Orig-DTAB */ return(NULL); }
		}
		if( a->type=='R' ){				// LVAL参照先 Address 値を RefA に設定する。
			if( (RefA=deref_a(a))==NULL ){ flag_exerr=E_REFIDX; last_ct=a_curr; /* Orig-DTAB */ return(NULL); }
		}

	/* >Do ASGN()!! */

	// 'R'<='R' : RefV 値を用いて、RefA 参照先 1[Byte] を直接書き換える。
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
		if( a->type=='R' && x->type=='R' )		/*** 0xFF -> Disable Sign Extension !! ***/
			{ *RefA = (*RefV)&0xFF;											goto L_NEXT; }

	// 'D'<='R' : RefV 値を用いて、LVAL DTAB 整数値を設定する。
		if( a->type!='R' && x->type=='R' )		/*** 0xFF -> Disable Sign Extension !! ***/
			{ udef_dtab(a); a->type='I'; a->ival=(*RefV)&0xFF;				goto L_NEXT; }

	// 'R'<='D' : LVAL DTAB 整数値を用いて、RefA 参照先 1[Byte] を直接書き換える。
		if( a->type=='R' && x->type!='R' )		/*** 0xFF -> Disable Sign Extension !! ***/
			{ last_ct=x_curr; chk_vtype(x,"ID",i); *RefA = cint(x)&0xFF;	goto L_NEXT; }

	// 'D'<='D' : LVAL DTAB 値を用いて、RVAL DTAB 値を設定する。(通常アサイン)
		if( a->type!='R' && x->type!='R' ){
			if( a!=x ){ udef_dtab(a); cpy_dtab(a,x); }			// Clear & Copy   ( if different  )
			if( x->type=='S' && ((x->attr)&ATTR_EDOL) ){		// Evaluate ${}   ( if applicable )
				a->str  = evaldol(x->str);						// >Try to Rewrite by Evaled String !!
				if( a->str!=x->str ) a->attr &= (~ATTR_EDOL);	// >Disable Propagation if Replaced !!
			}
	// もし、左辺が配列の要素であって、かつ、代入値がマトリクス値と成り得ない場合は、元配列のマトリクスフラグを消す。
			if( a->name==NULL && a->base!=NULL && !ismatv(x) ){ matx_dis(a->base); }
			goto L_NEXT;
		}

	/* >Assert!! */
		return NULL;

/* Next!! */
L_NEXT:
	// 右辺値が関数の時には、左辺値に ATTR_FXCP をセットする。( SEEK_ORIGFUNC() 対策 )
		if( x->type=='X')
			a->attr |= ATTR_FXCP;

/*----------------------------------------------------------------------------------------------*/
/* Do TRACE()!! */
	if( flag_trace>=rp ){				// RP = Func Nest Level (main=1)
		if( ck(lptr(ptr->l,i)) ){
			if( a->type!='A' ){ eprin("%s\n",dv(a)); }else{ eprin("%s\n",cv(a_root)); }
		}
	}
/*----------------------------------------------------------------------------------------------*/

	}
/* --- Multi Assign --- */
	return a_root;

}
