/*** ESUP.C - Bison(1) Support Code in C-Lang !!! ERROR !!! ***/

#define	r_whi(str)	(sbcolor(2)?"[00;01;07;37m":""),str,(sbcolor(2)?"[00m":"")  // 白色反転＋STR＋デフォルト for stderr

/************************************************************************************************/
// DIAG() diagnose result & display error message. [ Use LAST_CT,LAST_AR,LAST_FX and EPOS ]
/************************************************************************************************/
void diag(ctree *ptr){
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
ctree	*p_ctr;
dtab	*p2d = ctr2p_dtab( p_ctr=lptra(last_ct,epos) );
dtab	*a2d = ctr2p_dtab(       lptra(last_ar,0   ) );

/* 正常な場合はリターン */
if( ptr!=NULL || flag_exerr==0 ) return;

/* QCOL演算の場合 [ X ? Y : Z に対して epos が 0 ? 1 : 2 となる。] */
if( last_ct!=NULL && last_ct->op=='?' ){
	if( epos==1 )
		p2d = ctr2p_dtab( p_ctr=      last_ct->l         );
	else
		p2d = ctr2p_dtab( p_ctr=lptra(last_ct->r,epos-1) );
}

/* 配列の場合 */
if( p2d==NULL && p_ctr!=NULL && p_ctr->op==ARRY ){
	// 配列の場合、エラーフラグを一時的にクリアして ca2p_dtab() を実行し p2d を設定する。
	// エラーフラグがあると、ca2p_dtab() 内部で実行される eva_expr() が異常終了するため。
	int flag_dummy=flag_exerr; flag_exerr=0; p2d = ca2p_dtab(p_ctr); flag_exerr=flag_dummy;
}

/* エラー処理の本文 */
if( flag_exerr==NullPTR ) msg_r("Master!! - Illegal NullPTR /*** Internal Error!! ***/ %s" , eloc());
if( flag_exerr==NullSYS ) msg_r("Master!! - System(OS) Error /*** Internal Error!! ***/ %s", eloc());

if( flag_exerr==UnDEFD_V &&  isvoid(p2d) )
	msg_r("Master!! - Function %s%s()%s has no return value %s"	, r_whi( dn(ctr2p_dtab(last_fx)) ), eloc());
if( flag_exerr==UnDEFD_V && !isvoid(p2d) && p2d->ukey==NULL )
	msg_r("Master!! - Variable %s%s%s is undefined %s"			, r_whi( dn(p2d) ), eloc());
if( flag_exerr==UnDEFD_V && !isvoid(p2d) && p2d->ukey!=NULL )
	msg_r("Master!! - Array %s%s%s is undefined %s"				, r_whi( dn(p2d) ), eloc());

if( flag_exerr==UnDEFD_F )
	msg_r("Master!! - Function %s%s()%s is undefined %s"		, r_whi( dn(p2d) ), eloc());

if( flag_exerr==NgTYPE_V &&  dk(p2d) )
	msg_r("Master!! - Variable %s%s%s has illegal type <%c> %s"	, r_whi( dn(p2d) ), dt(p2d), eloc());
if( flag_exerr==NgTYPE_V && !dk(p2d) )
	msg_r("Master!! - Expression has illegal type <%c> %s"		,                              dt(p2d), eloc());

if( flag_exerr==NgTYPE_F )
	msg_r("Master!! - Identifier %s%s%s is not function %s"		, r_whi( dn(p2d) ), eloc());

if( flag_exerr==NgARGCmm && epar[1]==epar[2] )
	msg_r("Master!! - Illegal param count to %s%s()%s (Expect=%d) %s"		, r_whi( cn(last_fx) ), epar[1], eloc());
if( flag_exerr==NgARGCmm && epar[1]!=epar[2] && epar[1]>=0 && epar[2]>=0 )
	msg_r("Master!! - Illegal param count to %s%s()%s (Expect={%d-%d}) %s"	, r_whi( cn(last_fx) ), epar[1], epar[2], eloc());
if( flag_exerr==NgARGCmm && epar[1]==INVA )	/* ### <= ARGC <= Max */
	msg_r("Master!! - Too many param to %s%s()%s (Expect<=%d) %s"			, r_whi( cn(last_fx) ), epar[2], eloc());
if( flag_exerr==NgARGCmm && epar[2]==INVA )	/* Min <= ARGC <= ### */
	msg_r("Master!! - Too few param to %s%s()%s (Expect>=%d) %s"			, r_whi( cn(last_fx) ), epar[1], eloc());

if( flag_exerr==NgARGCnn && epar[3]==INVA )
	msg_r("Master!! - Illegal param count to %s%s()%s (Expect={%d|%d}) %s"   , r_whi( cn(last_fx) ), epar[1], epar[2], eloc());
if( flag_exerr==NgARGCnn && epar[3]!=INVA )
	msg_r("Master!! - Illegal param count to %s%s()%s (Expect={%d|%d|%d}) %s", r_whi( cn(last_fx) ), epar[1], epar[2], epar[3], eloc());

if( flag_exerr==NgARGGAP )
	msg_r("Master!! - You can't omit parameter for (SysDef)Func()%s"	, eloc());
if( flag_exerr==NgARGVAL )
	msg_r("Master!! - Variable %s%s%s has illegal value %s"				, r_whi( dn(p2d) ), eloc());
if( flag_exerr==NgARGCMB )
	msg_r("Master!! - illegal parameter combination %s"					,                              eloc());

if( flag_exerr==E_SCANER || flag_exerr==E_PARSER )
	; /* We don't display any message here, because {Scanner|Parser} should have displayed it. */
if( flag_exerr==E_REGEXP )
	msg_r("Master!! - format error in /RE/ %s%s%s %s"					, r_whi( p2d->str ), eloc());
if( flag_exerr==E_REGINF )
	msg_r("Master!! - /RE/ %s%s%s will match infinitly %s"				, r_whi( p2d->str ), eloc());
if( flag_exerr==E_ARYIDX && epar[0]=='U' )
	msg_r("Master!! - Array index in %s%s[]%s is undefined %s"			, r_whi( dn(a2d) ),          eloc());
if( flag_exerr==E_ARYIDX && epar[0]!='U' )
	msg_r("Master!! - Array index in %s%s[]%s is illegal type \'%c\' %s", r_whi( dn(a2d) ), epar[0], eloc());
if( flag_exerr==E_REFIDX )
	msg_r("Master!! - Index for variable %s%s%s is illegal value %s"	, r_whi( dn(a2d) ), eloc());
if( flag_exerr==E_FSCOPE )
	msg_r("Master!! - can define function in TopLevel only %s"			, eloc());

/* PRINT()関数 */
if( flag_exerr==PRiNARGC && epar[1]=='-' )
	msg_r("Master!! - %s() needs less params %s", cn(last_fx)  , eloc());
if( flag_exerr==PRiNARGC && epar[1]=='+' )
	msg_r("Master!! - %s() needs more params %s", cn(last_fx)  , eloc());
if( flag_exerr==PRiNTYPE )
	msg_r("Master!! - %s(%d) format is \'%%%c\' , but type is <%c> %s"	, cn(last_fx), epar[0], epar[1], epar[2], eloc());

/* ファイルI/O */
if( flag_exerr==FileOpen   )
	msg_r("Master!! - cannot open file %s%s%s %s"		, r_whi( p2d->str ), eloc());
if( flag_exerr==FileClose  )
	msg_r("Master!! - cannot close file %s%s%s %s"		, r_whi( p2d->str ), eloc());
if( flag_exerr==FileRead   )
	msg_r("Master!! - cannot read data from %s%s%s %s"	, r_whi( p2d->str ), eloc());
if( flag_exerr==FileWrite  )
	msg_r("Master!! - cannot write data into %s%s%s %s"	, r_whi( p2d->str ), eloc());
if( flag_exerr==FileFlush  )
	msg_r("Master!! - cannot flush file %s%s%s %s"		, r_whi( p2d->str ), eloc());
if( flag_exerr==FileGetPos  )
	msg_r("Master!! - cannot getpos from %s%s%s %s"		, r_whi( p2d->str ), eloc());
if( flag_exerr==FileSetPos  )
	msg_r("Master!! - cannot setpos into %s%s%s %s"		, r_whi( p2d->str ), eloc());

/* ネットワーク関係 */
if( flag_exerr==IpAddr  ){ msg_r("Master!! - Illegal IP-Address %s"   , eloc()); }
if( flag_exerr==PortNo  ){ msg_r("Master!! - Illegal Port-Number %s"  , eloc()); }
if( flag_exerr==ProtoID ){ msg_r("Master!! - Illegal Protocol-ID %s"  , eloc()); }
if( flag_exerr==LisnAcc ){ msg_r("Master!! - listen & accept error %s", eloc()); }
if( flag_exerr==Connect ){ msg_r("Master!! - connect error %s"        , eloc()); }
if( flag_exerr==RawRecv || flag_exerr==UdpRecv || flag_exerr==TcpRecv ){
	last_ct=last_fx; epos=0;	// Set error location to last_fx!!
	msg_r("Master!! - cannot recv packet by %s%s()%s %s", r_whi( cn(last_fx) ), eloc());
}
if( flag_exerr==RawSend || flag_exerr==UdpSend || flag_exerr==TcpSend ){
	last_ct=last_fx; epos=0;	// Set error location to last_fx!!
	msg_r("Master!! - cannot send packet by %s%s()%s %s", r_whi( cn(last_fx) ), eloc());
}

if( flag_exerr==MatxUndef && epar[0]==INVA )
	msg_r("Master!! - Matrix element %s%s%s[%d] is undefined %s"	, r_whi( dn(p2d) ),          epar[1], eloc());
if( flag_exerr==MatxUndef && epar[0]!=INVA )
	msg_r("Master!! - Matrix element %s%s%s[%d,%d] is undefined %s"	, r_whi( dn(p2d) ), epar[0], epar[1], eloc());

if( flag_exerr==MatxValue && epar[0]==INVA )
	msg_r("Master!! - Matrix element %s%s%s[%d] is illegal %s"		, r_whi( dn(p2d) ),          epar[1], eloc());
if( flag_exerr==MatxValue && epar[0]!=INVA )
	msg_r("Master!! - Matrix element %s%s%s[%d,%d] is illegal %s"	, r_whi( dn(p2d) ), epar[0], epar[1], eloc());

if( flag_exerr==MatxCombi )
	msg_r("Master!! - Illegal Matrix Combo (%dx%d) and (%dx%d) %s"	, epar[0], epar[1], epar[2], epar[3], eloc());
if( flag_exerr==MatxAttri )
	msg_r("Master!! - Array %s%s%s is not a Matrix %s"				, r_whi( dn(p2d) ), eloc());


if( flag_exerr==SortFxRetn  )
	msg_r("Master!! - illegal return value from sort func(). %s", eloc());
if( flag_exerr==SortFxExec  )
	msg_r("Master!! - exec error in sort func(). %s"			, eloc());
if( flag_exerr==SortInSort  )
	msg_r("Master!! - you can't call sort() inside sort(). %s"	, eloc());

/* PERROR for All!! */
	if( errno!=0 ){ perror("perror()"); }
}

/************************************************************************************************/
// YYERROR() display parser error message.  This function is required by Bison.  !!! MUST !!!
/************************************************************************************************/
void yyerror(char *str){
/*--1---2---3---4---5---6---7---8---9---A---B---C---D---E---F---G---H---I---J---K---L---M---N---*/
int		line=yylineno;
/* Display Message */
	if( flag_exerr==E_SCANER || flag_imode=='$' )
		;
	else{
		flag_exerr = E_PARSER;
		msg_r("YYERROR() - %s %s", str, sloc(sx,line));
	}
	return;
}
